



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>hashMap底层put和get方法逻辑</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">hashMap底层put和get方法逻辑</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 07:02:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>先看转载的一边文章：<a href="https://mp.weixin.qq.com/s/fZRPogkkUfBnhbZQB5r-uw" rel="external nofollow noreferrer">https://mp.weixin.qq.com/s/fZRPogkkUfBnhbZQB5r-uw</a></h2>
<h2>1.hashmap put方法的实现：</h2>
<div>
<pre class="prettyprint linenums"> public V put(K key, V value) {<br />
        if (key == null)<br />
            return putForNullKey(value);<br />
        int hash = hash(key);<br />
        int i = indexFor(hash, table.length);<br />
        for (Entry&lt;K,V&gt; e = table[i]; e != null; e = e.next) {<br />
            Object k;<br />
            if (e.hash == hash &amp;&amp; ((k = e.key) == key || key.equals(k))) {<br />
                V oldValue = e.value;<br />
                e.value = value;<br />
                e.recordAccess(this);<br />
                return oldValue;<br />
            }<br />
        }

        modCount++;<br />
        addEntry(hash, key, value, i);<br />
        return null;<br />
    }</pre>
</div>
<p>首先对key做null检查。如果key是null，会被存储到table[0]，因为null的hash值总是0。</p>
<p>key的hashcode()方法会被调用，然后计算hash值。hash值用来找到存储Entry对象的数组的索引。有时候hash函数可能写的很不好，所以JDK的设计者添加了另一个叫做hash()的方法，它接收刚才计算的hash值作为参数。如果你想了解更多关于hash()函数的东西，可以参考：hashmap中的hash和indexFor方法</p>
<p>indexFor(hash,table.length)用来计算在table数组中存储Entry对象的精确的索引。</p>
<p>在我们的例子中已经看到，如果两个key有相同的hash值(也叫冲突)，他们会以链表的形式来存储。所以，这里我们就迭代链表。</p>
<p>&middot;&nbsp;如果在刚才计算出来的索引位置没有元素，直接把Entry对象放在那个索引上。</p>
<p>&middot;&nbsp;如果索引上有元素，然后会进行迭代，一直到Entry-&gt;next是null。当前的Entry对象变成链表的下一个节点。</p>
<p>&middot;&nbsp;如果我们再次放入同样的key会怎样呢？逻辑上，它应该替换老的value。事实上，它确实是这么做的。在迭代的过程中，会调用equals()方法来检查key的相等性(key.equals(k))，如果这个方法返回true，它就会用当前Entry的value来替换之前的value。</p>
<h2>2.hashMap get方法的解析：</h2>
<div>
<pre class="prettyprint linenums">public V get(Object key) {<br />
        if (key == null)<br />
            return getForNullKey();<br />
        Entry&lt;K,V&gt; entry = getEntry(key);

        return null == entry ? null : entry.getValue();<br />
    }</pre>
</div>
<p>当你传递一个key从hashmap总获取value的时候：</p>
<p>对key进行null检查。如果key是null，table[0]这个位置的元素将被返回。</p>
<p>key的hashcode()方法被调用，然后计算hash值。</p>
<p>indexFor(hash,table.length)用来计算要获取的Entry对象在table数组中的精确的位置，使用刚才计算的hash值。</p>
<p>在获取了table数组的索引之后，会迭代链表，调用equals()方法检查key的相等性，如果equals()方法返回true，get方法返回Entry对象的value，否则，返回null。</p>
<h2>3.要牢记以下关键点：</h2>
<ol><li>&middot;&nbsp;HashMap有一个叫做Entry的内部类，它用来存储key-value对。</li>
<li>&middot;&nbsp;上面的Entry对象是存储在一个叫做table的Entry数组中。</li>
<li>&middot;&nbsp;table的索引在逻辑上叫做&ldquo;桶&rdquo;(bucket)，它存储了链表的第一个元素。</li>
<li>&middot;&nbsp;key的hashcode()方法用来找到Entry对象所在的桶。</li>
<li>&middot;&nbsp;如果两个key有相同的hash值，他们会被放在table数组的同一个桶里面。</li>
<li>&middot;&nbsp;key的equals()方法用来确保key的唯一性。</li>
<li>&middot;&nbsp;value对象的equals()和hashcode()方法根本一点用也没有。</li></ol>
<p><strong>简单地说，HashMap 在底层将 key-value 当成一个整体进行处理，这个整体就是一个 Entry 对象。HashMap 底层采用一个 Entry[] 数组来保存所有的 key-value 对，当需要存储一个 Entry 对象时，会根据hash算法来决定其在数组中的存储位置，在根据equals方法决定其在该数组位置上的链表中的存储位置；当需要取出一个Entry时， 也会根据hash算法找到其在数组中的存储位置，再根据equals方法从该位置上的链表中取出该Entry。</strong></p>
<h1>HashMap的resize（rehash）</h1>
<p>当hashmap中的元素越来越多的时候，碰撞的几率也就越来越高（因为数组的长度是固定的），所以为了提高查询的效率，就要对hashmap的数组进行扩容，数组扩容这个操作也会出现在ArrayList中，所以这是一个通用的操作，很多人对它的性能表示过怀疑，不过想想我们的&ldquo;均摊&rdquo;原理，就释然了，而在hashmap数组扩容之后，最消耗性能的点就出现了：原数组中的数据必须重新计算其在新数组中的位置，并放进去，这就是resize。</p>
<p>那么hashmap什么时候进行扩容呢？当hashmap中的元素个数超过数组大小*loadFactor时，就会进行数组扩容，loadFactor的默认值为0.75，也就是说，默认情况下，数组大小为16，那么当hashmap中元素个数超过16*0.75=12的时候，就把数组的大小扩展为2*16=32，即扩大一倍，然后重新计算每个元素在数组中的位置，而这是一个非常消耗性能的操作，所以如果我们已经预知hashmap中元素的个数，那么预设元素的个数能够有效的提高hashmap的性能。比如说，我们有1000个元素new HashMap(1000), 但是理论上来讲new HashMap(1024)更合适，不过上面annegu已经说过，即使是1000，hashmap也自动会将其设置为1024。 但是new HashMap(1024)还不是更合适的，因为0.75*1000 &lt; 1000, 也就是说为了让0.75 * size &gt; 1000, 我们必须这样new HashMap(2048)才最合适，既考虑了&amp;的问题，也避免了resize的问题。</p>
<p>　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx37evq.html">对于C&plus;&plus;窗口编译一闪而过的解决方法 （DEV CPP下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4rzne8.html">java 20 - 4 IO流概述和一个简单例子解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0mve4q.html">SAE平台的文件I&sol;O处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0l4jlq.html">RealSense 3D实感体验：前景广阔目前应用少</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdkknm8.html">Java &lbrack;leetcode 11&rsqb; Container With Most Water</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvl01oq.html">svn版本信息自动更新到源代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meknvrq.html">【Android Developers Training】 4&period; 启动另一个Activity</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy16xddq.html">201521145048《java程序设计》第10周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gexvrz8.html">C&num;-判断Shift&comma;Alt&comma;Ctrl是否被按下&comma;确定所按下的组合键</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pvr5v8.html">自主学习python文本进度条及&pi;的计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvdnel8.html">如何将maven配置在eclipse上</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdpx39.html">freemarker 简单操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj225j9.html">openERP笔记 自定义模块开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvlgj38.html">blfs（systemd版本）学习笔记-前几章节的脚本配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1nom9.html">Cookie的HttpOnly、secure、domain属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxv0z9.html">eclipse版本和jdk对应关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53lymq.html">C&plus;&plus;：vector中的v&period;at&lpar;0&rpar;和v&lbrack;0&rsqb;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllrxr6q.html">hdu number number number 斐波那契数列 思维</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kome35q.html">CodeForces - 812B   Sagheer&comma; the Hausmeister 搜索 dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emw71m9.html">PHP 5&period;6 如何使用 CURL 上传文件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8k3yj5q.html">java 部署服务报：Bad version number in &period;class file</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvg6pyq.html">Xcode 6&period;x 添加Empty Application模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/49555km9.html">数据库调优过程（一）：SqlServer批量复制&lpar;bcp&rpar;&lbrack;C&num;SqlBulkCopy&rsqb;性能极低问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjnn3z9.html">maven 建立ssh项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv5vkzq.html">RESTful架构详解&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wdwzlq.html">免安装版的MySQL的安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv516yq.html">UML&colon; 对象图</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmel1e9.html">Android--HTTP协议</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1gyk39.html">C&plus;&plus;之路进阶&mdash;&mdash;codevs4416（FFF的后宫）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k10jlr9.html">SPOJ COT2 Count on a tree II（树上莫队）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
